import string
import time
import os
import kraken.tools.TextUi as TextUi
from kraken.entrytypes.MetaData import loadMetaData

# constants for commands

class Runtime:
    
    def __init__(self):
        # command line arguments
        self.arguments = None
        # command line options
        self.outputFile = ""
        self.recursive = 0
        self.title = ""
        self.description = ""
        self.interactive = -1
        self.forceRegenerateCache = 0
        
        # FIXME: change to keywords
        self.tmpKeywords = ""
        self.keywords = []
        self.tmpDate = ""
        self.date = time.localtime()

        # the command
        self.theCommand = ""
        self.commandToDescribe = ""
        
        # runtime stuff
        self.entryDir = ""
        self.annotateEntry = None
        
        # queries
        self.selectKeywordsAll = None
        self.selectKeywordsAny = None
        self.selectTitleContains = None
        self.selectDescriptionContains = None
        
    def interactiveRead(self, system):
        metadata = loadMetaData(system, self)        
        self.title = TextUi.inputWithDefault("title", self.title)
        self.description = TextUi.inputWithDefault("description", self.description)
        self.keywords = TextUi.inputSequence("Keywords", self.keywords, metadata.keywords)

