import os.path
import logging
import kraken.tools.Utils as Utils
import kraken.tools.TextUi as TextUi
from kraken.entrytypes.MetaData import loadMetaData
import kraken.Constants

def description(system, runtime):
    t  = "Gathers the bibtex files from all the entries which have that and\n"
    t += "creates a file named " + kraken.Constants.DEFAULT_BIBTEX_FILE + " suitable as an\n"
    t += "input to bibtex.\n"
    return t

#
#  Execute the command
#
def execute(system, runtime):
    #print "Generating Bibtex..."
    metadata = loadMetaData(system, runtime)
    descriptor = metadata.descriptors["BibTex"]
    bibtexFile = "KrakenBibtex.bib"
    bibtexFile = TextUi.inputString("Name of bibtex file to generate:", bibtexFile)    
    FILE = open(bibtexFile, "w+")
    bibtexEntryCount = 0
    for entry in metadata.entries:        
        bibFilename = descriptor.getNativeFileName(entry) 
        if not os.path.exists(bibFilename):
           continue
        FILE.write("% Generated from kraken entry " + bibFilename + "\n")    
        BIBFILE = open(bibFilename)
        FILE.write(BIBFILE.read())
        BIBFILE.close()
        FILE.write("\n\n")
        bibtexEntryCount = bibtexEntryCount + 1
    FILE.close()
    print "Generated " + str(bibtexEntryCount) + " entries in file " + bibtexFile
