import kraken.Constants
import os.path
from types import *
import time

def paragraphField(entry, propertyName, label = None, cssClass=None, sequenceNewLine = 0):
    if cssClass == None:
        classPart = ""
    else:
        classPart = " class="+cssClass
    value = entry.getExtendedProperty(propertyName)
    if label == None:
        labelPart = ""
    else:
        labelPart = label + " = "
    valuePart = ""
    typeOfField = type(value)
    if typeOfField == ListType:
         valuePart = ""
         for a in value:
             valuePart += str(a)
             if sequenceNewLine:
                 valuePart += "<br/>\n"
             else:
                 valuePart += ", "
         if not sequenceNewLine:
             valuePart = valuePart[:-2] 
    elif (typeOfField == time.struct_time) or (typeOfField == TupleType and len(value)==9):  
         valuePart = time.strftime("%a, %d %b %Y %H:%M:%S +0000", value)
    else:
         valuePart = str(value)    
    return "<p class=" + classPart + ">" + labelPart + valuePart + "</p>\n"
    
        
def paragraphNativeMetaData(entry, metadata):
      temp = ""
      metadataDir = (entry.parentDirName + "/" + entry.getProperty("directoryName") + "/" + 
          kraken.Constants.DIRNAME_METADATA + "/")
      for a in metadata.descriptors.values():
          if a.getProperty("nativeFileName") != None:
             temp += linkNativeMetaData(metadataDir, a.getProperty("nativeFileName"), "[" + a.getProperty("name") + "]")
      return temp
        
    
def linkLocalFiles(entry):
   temp = ""    
   for x in entry.getProperty("localFileNames"):
        temp += ('<a href="file:///' + entry.parentDirName + "/" +
                     entry.getProperty("directoryName") + "/" + x + '">' +
                     entry.getProperty("title") + "</a><br/>\n"
                )
   if len(entry.getProperty("localFileNames")) == 0:
       if len(entry.getProperty("originalURIs")) != 0:
           for x in entry.getProperty("originalURIs"):
              temp += '<a href="' + x + '">' +  entry.getProperty("title") + "</a><br/>\n"
       else:
           temp += ('<a href="file:///' + entry.parentDirName + "/" + 
                    entry.getProperty("directoryName") + "/" + '">' + entry.getProperty("title")
                     + "</a>\n"
                    )
   return temp
    
    
def linkNativeMetaData(metadataDir, mdFile, mdLabel):
       # FIXME: this is for Windows       
       if os.path.exists(metadataDir + mdFile):
           return '<a href="file:///' + metadataDir + "/" + mdFile + '">' +  mdLabel + "</a>\n"
       else:
           return ""    
