import os.path
import kraken.Constants
import time
import FieldHelper

class TableFormat:

    def __init__(self):
        self.classTable = "maintable"
        self.classTdOdd = "maintable-odd"
        self.classTdEven = "maintable-even"
        self.classPdescription = "description"
        self.classPkeywords = "keywords"
        self.classPkrakenpos = "kraken-pos"

    '''
       Generates a table of lists based on the metadata information
    '''        
    def generateEntryTable(self, metadata, header):
       temp = ""
       temp +='<table class=' + self.classTable + ' cols=2 width="100%" cellspacing="0">\n'
       temp += header
       odd = 1              
       for a in metadata.entries:
          if odd:
              csscell = self.classTdOdd
              odd = 0
          else:
              csscell = self.classTdEven
              odd = 1
          temp += self.generateEntryRow(a, metadata, csscell)    
       temp += "</table>\n"
       return temp

    def generateEntryRow(self, entry, metadata, csscell):   
       # create the row
       temp = "<tr>\n"
       temp += self.generatePrimaryCell(entry, metadata, csscell)
       temp += self.generateSecondaryCell(entry, metadata, csscell)
       # end of row
       temp += "</tr>\n"
       return temp
       
    def generatePrimaryCell(self, entry, metadata, csscell):
       temp = ""
       # first cell: title, description
       temp += '<td class=' + csscell + ' width="70%">'
       temp += FieldHelper.linkLocalFiles(entry)
       temp += FieldHelper.paragraphField(entry, "description", cssClass = self.classPdescription)
       temp += FieldHelper.paragraphNativeMetaData(entry, metadata)
       temp += "</td>\n"
       return temp

    def generateSecondaryCell(self, entry, metadata, csscell):
       temp = ""
       # second cell: original URL, date
       temp += '<td class=' + csscell + '>\n'
       temp += FieldHelper.paragraphField(entry, "originalURIs", sequenceNewLine = 1)
       temp += FieldHelper.paragraphField(entry, "date", label = "Date: ", cssClass = "date")
       temp += FieldHelper.paragraphField(entry, "keywords", "Keywords:")
       temp += FieldHelper.paragraphField(entry, "directoryName", label = "Entry", cssClass = self.classPkrakenpos) 
       temp += "</td>\n"
       return temp
       

        
