import kraken.tools.TextUi as TextUi
from Filters import *
from Sorters import *
from Query import *
from Classifiers import *
from Limiter import *
import kraken.Constants
import os.path
import os
import pickle

def createQueryWithVerify(system, metadata):
  que =  Query()
  que.name = TextUi.inputString("Name of the query")  
  while 1:  
    menuitems = [
       "Accept this query",
       "Save query to file",
       "Load query from file",
       "Add an element to this query",
       "Print result of query", 
       "Create a different query"
    ]
    choice = TextUi.inputMenu("Enter your choice", menuitems)
    if choice == "Accept this query":
        return que
    if choice == "Print result of query":
        md = que.processMetaData(system, metadata)
        for entry in md.entries:
            print md
        continue
    if choice == "Add an element to this query":
        menuitems = [
            "Filter",
            "Sorter",
            "Limiter",
            "Classifier"
        ]
        ch2 = TextUi.inputMenu("Enter your choice", menuitems)
        if ch2 == "Filter":
            flt = createFilterWithVerify(system, metadata)
            que.queryElements.append(flt)
            continue
        if ch2 == "Sorter":
            srtr = createSorterWithVerify(system, metadata)
            que.queryElements.append(srtr)
            continue
        if ch2 == "Limiter":
            lim = createLimiter(system, metadata)
            que.queryElements.append(lim)
            continue
        if ch2 == "Classifier":
            cla = createClassifier(system, metadata)
            que.queryElements.append(cla)
            continue        
    if choice == "Create a different query":
        que = Query()
        continue
    if choice == "Save query to file":
        filename = TextUi.inputString("Enter filename:")
        queryFile = os.path.join(system.getProperty("filterDir"), 
            filename + kraken.Constants.EXTENSION_QUERY)
        FILE = open(queryFile, "w")    
        pickle.dump(que, FILE)
        FILE.close()
        print "Query saved to " + queryFile
        continue
    if choice == "Load query from file":
       lst = os.listdir(system.getProperty("filterDir"))
       queries = []
       for a in lst: 
           if a[-4:] == kraken.Constants.EXTENSION_QUERY:
               queries.append(a[0:-4])
       if len(lst) == 0:
           print "There are no saved queries"
           return
       choice = TextUi.inputMenu("Choose the query to load", queries)
       queryFile = os.path.join(system.getProperty("filterDir"), 
            choice + kraken.Constants.EXTENSION_QUERY)
       FILE = open(queryFile)
       que = pickle.load(FILE)
       FILE.close()
       continue
    

"""
    This is a selection filter to use for 1
    Returns the filtered metadata
"""
def createSelectionFilter(system, metadata):    
  flt = AndFilter()
  while 1:     
     subflt = createFilter(system, metadata)
     flt.filters.append(subflt)
     md = flt.processMetaData(metadata)
     print "The filter matches " + str(len(md.entries)) + " entries."
     if len(md.entries) == 1:
        print md.entries[0]
        if TextUi.confirm("This is the desired entry?"):
           return md
     menuitems = [
       "Narrow the filter",
       "Restart",
       "Select by hand" 
     ]
     choice = TextUi.inputMenu("Enter your choice", menuitems)
     if choice == "Narrow the filter":
         continue
     if choice == "Restart":
         flt = AndFilter()
         continue
     if choice == "Select by hand":
         lst = []
         for a in md.entries:
             lst.append(a.getProperty("title"))
         choice = TextUi.inputMenu("Choose from entries", lst)
         for a in md.entries:
             if a.getProperty("title") == choice:
                 md.entries = [a]
                 break
         return md
    

def createFilterWithVerify(system, metadata):
  flt = None
  while 1:  
    if flt == None:
       flt = createFilter(system, metadata)
    if flt != None:   
       md = flt.processMetaData(metadata)
       print "The filter matches " + str(len(md.entries)) + " entries."
    menuitems = [
       "Accept this filter",
       "Save filter to file",
       "List matching entries", 
       "Create a different filter"
    ]
    choice = TextUi.inputMenu("Enter your choice", menuitems)
    if choice == "Accept this filter":
        return flt
    if choice == "List matching entries":
        for entry in md.entries:
            print entry.getProperty("Title")
    if choice == "Create a different filter":
        flt = None
    if choice == "Save filter to file":
        filterName = TextUi.inputString("Enter filter name:")
        filterFile = os.path.join(system.getProperty("filterDir"), 
            filterName + kraken.Constants.EXTENSION_FILTER)
        FILE = open(filterFile, "w")    
        pickle.dump(flt, FILE)
        FILE.close()
        print "Filter saved to " + filterFile

        
def createSorterWithVerify(system, metadata):
   sorter = None
   while 1:
       if sorter == None:
           sorter = createSorter(system)
       if sorter != None:
           md = sorter.processMetaData(metadata)
       print "The created sorter is: " + str(sorter) + "\n"
       menuitems = [
          "Accept this sorter",
          "Save sorter to file",
          "List the entries sorted by this sorter", 
          "Create a different sorter",
       ]
       choice = TextUi.inputMenu("Enter your choice", menuitems)
       if choice == "Accept this sorter":
           return sorter
       if choice == "List the entries sorted by this sorter":
           for entry in md.entries:
              print entry.getProperty("Title")
       if choice == "Create a different sorter":
           sorter = None
       if choice == "Save sorter to file":
           sorterName = TextUi.inputString("Enter sorter name:")
           sorterFile = os.path.join(system.getProperty("filterDir"), 
              sorterName  + kraken.Constants.EXTENSION_SORTER)
           FILE = open(sorterFile, "w")
           pickle.dump(sorter, FILE)
           FILE.close()
           print "Sorter saved to " + sorterFile
        

def editEvaluationFilter(flt, metadata):
   # FIXME: develop a way to list them...
   while(1):
       lst = metadata.getAllPropertyNames()
       flt.propertyName = TextUi.inputString("Property name (? for a list)")
       if flt.propertyName == "?":
           print lst
       if flt.propertyName in lst:
           break
       print flt.propertyName + " is not a valid property!!!"
       print "Choose on of" + str(lst)
   flt.filterValue = TextUi.inputString("Value")
    
        
def createFilter(system, metadata):
   menuitems = [
                "Load filter",                
                "Free format filter",
                "Substring filter", 
                "Equal", 
                "Contains all keywords", 
                "Contains any keywords",
                "Has entry type",
                "Logical operations",
                "Pass-all filter"
   ]
   choice = TextUi.inputMenu("Enter your choice", menuitems)
   if choice == "Pass-all filter":
       flt = NoFilter()
       return flt
   if choice == "Equal":
       flt = EqualityFilter()
       editEvaluationFilter(flt, metadata)
       return flt
   if choice == "Contains all keywords":
       flt = ContainsAllFilter()
       flt.propertyName = "keywords"
       flt.filterValue = TextUi.inputSequence("List of keywords")
       print flt.filterValue
       return flt
   if choice == "Contains any keywords":
       flt = ContainsAnyFilter()
       flt.propertyName = "keywords"
       flt.filterValue = TextUi.inputSequence("List of keywords")
       return flt
   if choice == "Has entry type":
       flt = ContainsAnyFilter()
       flt.propertyName = "entryTypes"
       flt.filterValue = TextUi.inputEntryTypes(metadata)
       return flt
   if choice == "Substring filter":
       flt = SubstringFilter()
       editEvaluationFilter(flt, metadata)
       return flt
   if choice == "Free format filter":
       flt = FreeformatFilter()
       flt.filterValue = TextUi.inputString("Value")
       return flt
   if choice == "Load filter":
       lst = os.listdir(system.getProperty("filterDir"))
       filters = []
       for a in lst: 
           if a[-4:] == kraken.Constants.EXTENSION_FILTER:
               filters.append(a[0:-4])
       if len(lst) == 0:
           print "There are no saved filters"
           return
       choice = TextUi.inputMenu("Choose the filter to load", filters)
       filterFile = os.path.join(system.getProperty("filterDir"), 
            choice + kraken.Constants.EXTENSION_FILTER)
       FILE = open(filterFile)
       flt = pickle.load(FILE)
       FILE.close()
       return flt
   if choice == "Logical operations":
       return createLogicalOperationFilter(system, metadata)
   print choice + " not supported yet!!!"
       
       
def createLogicalOperationFilter(system, metadata):
   menuitems = [
                "NOT filter",
                "AND filter", 
                "OR filter", 
   ]
   choice = TextUi.inputMenu("Enter your choice", menuitems)
   if choice == "NOT filter":
       flt = NotFilter()
       print "Specify the filter to be negated"
       flt.flt = createFilter(system, metadata)
       return flt
   elif choice == "AND filter":
       flt = AndFilter()
       while 1:
           print "Specify the filter to add to this AND filter"
           subflt = createFilter(system, metadata)
           flt.filters.append(subflt)
           print "AND Filter is now:" + str(flt)
           val = TextUi.confirm("Do you want to add more subfilters to this AND filter?")
           if not val:
               return flt
   elif choice == "OR filter":
       flt = OrFilter()
       while 1:
           print "Specify the filter to add to this OR filter"
           subflt = createFilter(system, metadata)
           flt.filters.append(subflt)
           print "OR Filter is now:" + str(flt)
           val = TextUi.confirm("Do you want to add more subfilters to this OR filter?")
           if not val:
               return flt
    

def createSorter(system):
    menuitems = ["No sorting",
                 "Limit length",
                 "Reverse sorting", 
                 "Property based sorting", 
                 "Preferred value sorting",
                 "Multilevel sorting",
                 "Load sorting"
                 ]
    choice = TextUi.inputMenu("Enter your choice", menuitems)
    if choice == "No sorting":
        return NoSorting()
    if choice == "Property based sorting":
        sorting = EvaluationSorter()
        # FIXME: property lists
        sorting.propertyName = TextUi.inputString("Sort by property")
        return sorting
    if choice == "Reverse sorting":
        sorting = ReverseSorting()
        print "Now, create the sorter which is reversed!!!\n"
        sorting.theSorter = createSorter()
        return sorting
    if choice == "Load sorting":
       lst = os.listdir(system.getProperty("filterDir"))
       sorters = []
       for a in lst: 
           if a[-4:] == kraken.Constants.EXTENSION_SORTER:
               sorters.append(a[0:-4])
       if len(lst) == 0:
           print "There are no saved sortings"
           return
       choice = TextUi.inputMenu("Choose the sorting to load", filters)
       sorterFile = os.path.join(system.getProperty("filterDir"), 
            choice + kraken.Constants.EXTENSION_SORTER)
       FILE = open(sorterFile)            
       sorting = pickle.load(FILE)
       FILE.close()
       return sorting
        
    print choice + " not supported yet!!! - returning No Sorting"
    return NoSorting()
    
